
#include <stdio.h>

unsigned long glngFilePointer;
unsigned long glngMaxGopAddr, glngNextGopAddr;
unsigned long glngMaxPictureSizeSum;
unsigned long glngMaxGopFirstPicture, glngMaxGopLastPicture;
int gbIsSystemMpeg, gbLastPicture;
FILE *gFp;

int sngGetDemuxedPicture();
int sngGetPicture();
void CheckGop();

int sngGetDemuxedPicture()
{
	static long lngLength = 0;
	int sngValue0, sngValue1, sngValue2, sngValue3;
	int i, sngRetVal = EOF;
	
	if (lngLength == 0)
	{
		sngValue0 = sngValue1 = sngValue2 = 0xff;
		
		while (lngLength == 0 && (sngValue3 = fgetc(gFp)) != EOF)
		{
			// Search Marker of Video Stream
			if (sngValue0 == 0x00 && sngValue1 == 0x00 && sngValue2 == 0x01 && sngValue3 == 0xe0)
			{
				// Packet Length
				lngLength  = fgetc(gFp) * 256;
				lngLength += fgetc(gFp);
				
				// Stuffing Bytes
				i = 0;
				while (i < 16)
				{
					if (fgetc(gFp) == 0xff)
					{
						i++;
						lngLength--;
					}
					else
					{
						i = 16;
						fseek(gFp, -1, SEEK_CUR);
					}
				}
				
				// 2bit Control
				if ((fgetc(gFp) & 0xc0) != 0x80)
				{
					fseek(gFp, -1, SEEK_CUR);
					
					// STD Buffer Scale Size
					if ((fgetc(gFp) & 0xc0) == 0x40)
					{
						fseek(gFp, 1, SEEK_CUR);
						lngLength -= 2;
					}
					else
					{
						fseek(gFp, -1, SEEK_CUR);
					}
					// PTS, DTS
					sngValue0 = fgetc(gFp);
					fseek(gFp, -1, SEEK_CUR);
					if (sngValue0 == 0x0f)
					{
						// Header End
						fseek(gFp, 1, SEEK_CUR);
						lngLength -= 1;
					}
					else if ((sngValue0 & 0xf0) == 0x20)
					{
						// PTS
						fseek(gFp, 5, SEEK_CUR);
						lngLength -= 5;
					}
					else if ((sngValue0 & 0xf0) == 0x30)
					{
						// PTS
						fseek(gFp, 5, SEEK_CUR);
						lngLength -= 5;
						// DTS
						sngValue1 = fgetc(gFp);
						fseek(gFp, -1, SEEK_CUR);
						if ((sngValue1 & 0xf0) == 0x10)
						{
							fseek(gFp, 5, SEEK_CUR);
							lngLength -= 5;
						}
					}
				}
				else
				{
					fseek(gFp, -1, SEEK_CUR);
					
					// "10" & Flag & Control
					fseek(gFp, 2, SEEK_CUR);
					lngLength -= 2;
					// PES Header Length
					sngValue0 = fgetc(gFp);
					lngLength -= 1;
					// PES Header
					fseek(gFp, sngValue0, SEEK_CUR);
					lngLength -= sngValue0;
				}
			}
			else
			{
				sngValue0 = sngValue1;
				sngValue1 = sngValue2;
				sngValue2 = sngValue3;
			}
		}
	}
	if (lngLength > 0)
	{
		sngRetVal = fgetc(gFp);
		lngLength--;
	}
	
	return sngRetVal;
}

int sngGetPicture()
{
	glngFilePointer++;
	
	if (gbIsSystemMpeg)
		return sngGetDemuxedPicture();
	else
		return fgetc(gFp);
}

void CheckGop()
{
	int sngValue0, sngValue1, sngValue2, sngValue3;
	unsigned long lngGopAddr, lngPictureAddr;
	unsigned long lngMaxGopPictureSizeSum, lngPictureSizeSum;
	unsigned long lngPictureSize, lngPictureSize0, lngPictureSize1;
	int sngPictureType;
	unsigned long lngGopFirstPicture, lngPictureCount;
	
	sngValue0 = sngValue1 = sngValue2 = 0xff;
	glngMaxPictureSizeSum = 0;
	lngPictureAddr = 0;
	lngPictureCount = 0;
	
	fseek(gFp, 0, SEEK_SET);
	glngFilePointer = 0;
	
	while ((sngValue3 = sngGetPicture()) != EOF)
	{
		if (sngValue0 == 0x00 && sngValue1 == 0x00 && sngValue2 == 0x01)
		{
			if (sngValue3 == 0x00)
			{
				// PICTURE START
				if (lngPictureAddr == 0)
					// First Picture in Gop
					lngPictureSize = 0;
				else
					lngPictureSize = (glngFilePointer - 4) - lngPictureAddr;
				
				if (sngPictureType == 1)
				{
					// Previous Picture Type is I
					lngPictureSize0 = lngPictureSize;
					lngPictureSize1 = 0;
					lngPictureSizeSum = lngPictureSize0;
				}
				else if (sngPictureType == 2)
				{
					// Previous Picture Type is P
					lngPictureSize1 = lngPictureSize;
					lngPictureSizeSum = lngPictureSize0 + lngPictureSize1;
				}
				else if (sngPictureType == 3)
				{
					// Previous Picture Type is B
					lngPictureSizeSum = lngPictureSize0 + lngPictureSize1 + lngPictureSize;
				}
				if (lngPictureSizeSum > lngMaxGopPictureSizeSum)
					lngMaxGopPictureSizeSum = lngPictureSizeSum;
				
				// Get Picture Type
				sngValue0 = sngGetPicture();
				sngPictureType = (sngGetPicture() & 0x38) >> 3;
				
				lngPictureAddr = glngFilePointer - 4;
				lngPictureCount++;
				gbLastPicture = 0;
			}
			if (sngValue3 == 0xb3)
			{
				// SEQUENCE START
				if (lngPictureAddr != 0)
				{
					// Last Picture in Previous GOP
					lngPictureSize = (glngFilePointer - 4) - lngPictureAddr;
					if (sngPictureType == 1)
					{
						// Previous Picture Type is I
						lngPictureSize0 = lngPictureSize;
						lngPictureSize1 = 0;
						lngPictureSizeSum = lngPictureSize0;
					}
					else if (sngPictureType == 2)
					{
						// Previous Picture Type is P
						lngPictureSize1 = lngPictureSize;
						lngPictureSizeSum = lngPictureSize0 + lngPictureSize1;
					}
					else if (sngPictureType == 3)
					{
						// Previous Picture Type is B
						lngPictureSizeSum = lngPictureSize0 + lngPictureSize1 + lngPictureSize;
					}
					if (lngPictureSizeSum > lngMaxGopPictureSizeSum)
						lngMaxGopPictureSizeSum = lngPictureSizeSum;
					if (lngMaxGopPictureSizeSum > glngMaxPictureSizeSum)
					{
						glngMaxPictureSizeSum = lngMaxGopPictureSizeSum;
						glngMaxGopAddr = lngGopAddr;
						glngNextGopAddr = glngFilePointer - 4;
						glngMaxGopFirstPicture = lngGopFirstPicture;
						glngMaxGopLastPicture = lngPictureCount;
						gbLastPicture = 1;
						printf("Max Picture Size  = %d KB\n", (int)(glngMaxPictureSizeSum / 1024));
					}
					else if (lngMaxGopPictureSizeSum > 224 * 1024)
					{
						printf("    Picture Size  = %d KB\n", (int)(lngMaxGopPictureSizeSum / 1024));
					}
				}
				lngPictureSize0 = lngPictureSize1 = 0;
				sngPictureType = 0;
				lngGopAddr = glngFilePointer - 4;
				lngMaxGopPictureSizeSum = 0;
				lngPictureAddr = 0;
				lngGopFirstPicture = lngPictureCount;
			}
			if (sngValue3 == 0xb7)
			{
				// SEQUENCE END
				if (lngPictureAddr != 0)
				{
					// Last Picture in Previous GOP
					lngPictureSize = (glngFilePointer - 4) - lngPictureAddr;
					if (sngPictureType == 1)
					{
						// Previous Picture Type is I
						lngPictureSize0 = lngPictureSize;
						lngPictureSize1 = 0;
						lngPictureSizeSum = lngPictureSize0;
					}
					else if (sngPictureType == 2)
					{
						// Previous Picture Type is P
						lngPictureSize1 = lngPictureSize;
						lngPictureSizeSum = lngPictureSize0 + lngPictureSize1;
					}
					else if (sngPictureType == 3)
					{
						// Previous Picture Type is B
						lngPictureSizeSum = lngPictureSize0 + lngPictureSize1 + lngPictureSize;
					}
					if (lngPictureSizeSum > lngMaxGopPictureSizeSum)
						lngMaxGopPictureSizeSum = lngPictureSizeSum;
					if (lngMaxGopPictureSizeSum > glngMaxPictureSizeSum)
					{
						glngMaxPictureSizeSum = lngMaxGopPictureSizeSum;
						glngMaxGopAddr = lngGopAddr;
						glngNextGopAddr = glngFilePointer - 4;
						glngMaxGopFirstPicture = lngGopFirstPicture;
						glngMaxGopLastPicture = lngPictureCount;
						gbLastPicture = 1;
						printf("Max Picture Size  = %d KB\n", (int)(glngMaxPictureSizeSum / 1024));
					}
					else if (lngMaxGopPictureSizeSum > 224 * 1024)
					{
						printf("    Picture Size  = %d KB\n", (int)(lngMaxGopPictureSizeSum / 1024));
					}
				}
			}
			sngValue0 = sngValue1 = sngValue2 = 0xff;
		}
		else
		{
			sngValue0 = sngValue1;
			sngValue1 = sngValue2;
			sngValue2 = sngValue3;
		}
	}
}

void main(int argc, char **argv)
{
	char strVFName1[256], strVFName2[256], strVFName3[256];
	int sngValue0, sngValue1, sngValue2, sngValue3;
	unsigned long i;
	FILE *Fp;
	
	if ((gFp = fopen(argv[1], "rb")) != NULL)
	{
		fseek(gFp, 0, SEEK_SET);
		sngValue0 = fgetc(gFp);
		sngValue1 = fgetc(gFp);
		sngValue2 = fgetc(gFp);
		sngValue3 = fgetc(gFp);
		fseek(gFp, 0, SEEK_SET);
		
		if (sngValue0 == 0x00 && sngValue1 == 0x00 && sngValue2 == 0x01 && sngValue3 == 0xba)
			gbIsSystemMpeg = 1;
		else
			gbIsSystemMpeg = 0;
		CheckGop();
		
		printf("\n");
		printf("Max Picture Size  = %d KB\n", (int)(glngMaxPictureSizeSum / 1024));
		printf("GOP Picture Range = %d frame - %d frame\n", glngMaxGopFirstPicture, glngMaxGopLastPicture - 1);
		
		if (argc > 2)
		{
			fseek(gFp, 0, SEEK_SET);
			glngFilePointer = 0;
			
			if (glngMaxGopFirstPicture > 0)
			{
				sprintf(strVFName1, "%s_1.m2v", argv[2]);
				Fp = fopen(strVFName1, "wb");
				for (i = 0; i < glngMaxGopAddr; i++)
					fputc(sngGetPicture(), Fp);
				fputc(0x00, Fp); fputc(0x00, Fp); fputc(0x01, Fp); fputc(0xb7, Fp);
				fclose(Fp);
			}
			
			sprintf(strVFName2, "%s_2.m2v", argv[2]);
			Fp = fopen(strVFName2, "wb");
			for (i = glngMaxGopAddr; i < glngNextGopAddr; i++)
				fputc(sngGetPicture(), Fp);
			fputc(0x00, Fp); fputc(0x00, Fp); fputc(0x01, Fp); fputc(0xb7, Fp);
			
			if (gbLastPicture == 0)
			{
				sprintf(strVFName3, "%s_3.m2v", argv[2]);
				Fp = fopen(strVFName3, "wb");
				while((sngValue0 = sngGetPicture()) != EOF)
					fputc(sngValue0, Fp);
				fclose(Fp);
			}
		}
		fclose(gFp);
	}
}

